var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
// import './Scroll.css';
import React from 'react';
import { createKeyframes, endAnimation, findDivByRef, generateHashStringByLength, setAnimation, } from '../utils/functions';
import { basicClassName } from '../utils/constants';
export default function ScrollAnimationItem(_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? 1200 : _c, _d = _a.path, path = _d === void 0 ? 'top' : _d, rest = __rest(_a, ["children", "delay", "duration", "path"]);
    var ref = React.useRef(null);
    var hashClassName = generateHashStringByLength(5);
    var className = basicClassName + " ssa-" + hashClassName;
    function onScroll() {
        var element = findDivByRef(ref.current);
        var _a = element.getBoundingClientRect(), elementTopPosition = _a.top, elementHeight = _a.height;
        if ((window.innerHeight + elementHeight) / 2 > elementTopPosition) {
            setAnimation(element, duration, delay, path);
            setTimeout(endAnimation(element), duration);
            window.removeEventListener('scroll', onScroll);
        }
    }
    React.useEffect(function () {
        createKeyframes();
    }, []);
    React.useEffect(function () {
        window.addEventListener('scroll', onScroll);
        return function () { return window.removeEventListener('scroll', onScroll); };
    });
    return (_jsx("div", __assign({ className: className, style: styles, ref: ref }, rest, { children: children }), void 0));
}
var styles = {
    position: 'relative',
    width: '100%',
    height: '200px',
    opacity: '0',
    border: '1px solid green',
};
//# sourceMappingURL=ScrollAnimationItem.js.map